--- a/cpp/CMakeLists.txt
+++ b/cpp/CMakeLists.txt
@@ -26,7 +26,7 @@
 # Get GIT changeset, if available
 find_program(GIT_FOUND git)
 
-if(GIT_FOUND)
+if(GIT_FOUND AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
   # Get the commit hash of the working branch
   execute_process(
     COMMAND git rev-parse HEAD
@@ -34,6 +34,8 @@
     OUTPUT_VARIABLE GIT_COMMIT_HASH
     OUTPUT_STRIP_TRAILING_WHITESPACE
   )
+elseif(DEFINED DEBIAN_VERSION_ID)
+  set(GIT_COMMIT_HASH ${DEBIAN_VERSION_ID})
 else()
   set(GIT_COMMIT_HASH "unknown")
 endif()
